__version__='0.0.1'

import string,os
import re
from random import randint

# misc stuff  

# Language constants
HOUR = 'hour'
HOURS = 'hours'
YEAR = 'year'
YEARS = 'years'
MONTH = 'month'
MONTHS = 'months'
DAY = 'day'
DAYS = 'days'
AND = 'and'
FINISH = 'old'

def safeId(id):
    """ make sure only letters and numbers and a
        few other things slips through
    """
    allowed = string.letters + string.digits
    nid=''
    for l in list(id):
        if l in list(allowed):
            nid +=l
    return nid

def timeSince(firstdate, seconddate, use_oldword=1):
    """
     Use two date objects to return in plain english the difference between them.
     E.g. "3 years and 2 days"
      or  "1 year and 3 months and 1 day"
     If less than 1 day, return number of hours.

     If there is "no difference" between them, return false.
    """
    if not use_oldword:
        FINISH = ''
    fdo = firstdate
    sdo = seconddate

    day_difference = int(abs(sdo-fdo))

    years = day_difference/365
    months = (day_difference % 365)/30
    days = (day_difference % 365) % 30

    if days == 0:
        # use hours
        hours=int(abs(sdo-fdo)*24)
        if hours == 1:
            return "1 %s %s" % (HOUR, FINISH)
        elif hours > 0:
            return "%s %s %s" % (hours, HOURS, FINISH)
        else:
            # if the difference is smaller than 1 hour, 
            # return it false
            return 0
    else:
        s = []
        if years == 1:
            s.append('1 %s'%(YEAR))
        elif years > 1:
            s.append('%s %s'%(years,YEARS))
        
        if months == 1:
            s.append('1 %s'%MONTH)
        elif months > 1:
            s.append('%s %s'%(months,MONTHS))
        
        if days == 1:
            s.append('1 %s'%DAY)
        elif days > 1:
            s.append('%s %s'%(days,DAYS))
        
        if len(s)>1:
            return "%s %s" % (string.join(s,' %s '%AND), FINISH)
        else:
            return "%s %s" % (s[0], FINISH)

def _ShouldBeNone(result): return result is not None
def _ShouldNotBeNone(result): return result is None

tests = (
    # Thank you Bruce Eckels for these
  (re.compile("^[0-9a-zA-Z\.\-\_]+\@[0-9a-zA-Z\.\-]+$"), _ShouldNotBeNone, "Failed a"),
  (re.compile("^[^0-9a-zA-Z]|[^0-9a-zA-Z]$"), _ShouldBeNone, "Failed b"),
  (re.compile("([0-9a-zA-Z]{1})\@."), _ShouldNotBeNone, "Failed c"),
  (re.compile(".\@([0-9a-zA-Z]{1})"), _ShouldNotBeNone, "Failed d"),
  (re.compile(".\.\-.|.\-\..|.\.\..|.\-\-."), _ShouldBeNone, "Failed e"),
  (re.compile(".\.\_.|.\-\_.|.\_\..|.\_\-.|.\_\_."), _ShouldBeNone, "Failed f"),
  (re.compile(".\.([a-zA-Z]{2,3})$|.\.([a-zA-Z]{2,4})$"), _ShouldNotBeNone, "Failed g"),
)
def ValidEmailAddress(address, debug=None):
    for test in tests:
        if test[1](test[0].search(address)):
            if debug: return test[2]
            return 0
    return 1


def cookIdAndTitle(s):
    """ if s='image1~Image One.gif' then return ['image1.gif','Image One']

        Testwork:
        s='image1~Image One.gif'    => ['image1.gif','Image One']
        s='image1.gif'              => ['image1.gif','']
        s='image1~.gif'             => ['image1.gif','']
        s='image1~Image One.gif.gif'=> ['image1.gif','Image One.gif']
    """
    if s.find('~') == -1:
        return s, ''
    splitted = s.split('~',1)
    id = splitted[0]
    rest = s.replace(id+'~','')
    if rest.rfind('.') == -1:
        return id, rest
    else:
        pos_last_dot = rest.rfind('.')
        ext = rest[pos_last_dot:]
        id = id.strip() + ext.strip()
        title = rest[0:pos_last_dot].strip()
        return id, title


def nonEmptyList(lst):
    nlst=[]
    for i in lst:
        if i!='':
            nlst.append(i)
    return nlst



def generateRandomMessageId(length=10):
    pool="abcdefghijklmnopqrstuvwxyz"
    pool=pool+pool.upper()
    id=[]
    for i in range(length):
        id.append(pool[randint(0,len(pool)-1)])
    return string.join(id,'')

